SystemOrganization addCategory: #BinaryModules!

!MultiByteFileStream methodsFor: '*BinaryModules' stamp: 'lw 12/21/2012 14:52'!
nextPutAll: aCollection

	(self isBinary or: [aCollection class == ByteArray]) ifTrue: [
		^ super nextPutAll: aCollection.
	].
	aCollection class == WordArrayForSegment ifTrue: [
		^ super nextPutAll: (Bitmap withAll: aCollection) asByteArray
	].
	^converter nextPutAll: aCollection toStream: self! !

Object subclass: #BMPackage
	instanceVariableNames: 'name root segment outPointers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BinaryModules'!

!BMPackage class methodsFor: 'as yet unclassified' stamp: 'RL 1/9/2013 11:43'!
fromFile: fileName
	| package |
	package := FLMaterializer materializeFromFileNamed: fileName.
	^ (package isKindOf: BMPackage)
		ifTrue: [ package ]
		ifFalse: [ nil ]! !

!BMPackage class methodsFor: 'as yet unclassified' stamp: 'RL 1/9/2013 12:03'!
named: name
	^ super new
		name: name;
		yourself! !

!BMPackage class methodsFor: 'as yet unclassified' stamp: 'RL 1/9/2013 11:18'!
new
	self shouldNotImplement! !

!BMPackage class methodsFor: 'as yet unclassified' stamp: 'RL 1/9/2013 11:30'!
packageFileExtension
	^ '.pkg'! !

!BMPackage methodsFor: 'as yet unclassified' stamp: 'RL 1/9/2013 12:17'!
export: roots
	| imageSegment |
	imageSegment := ImageSegment new
		copyFromRoots: roots asArray sizeHint: 1000;
		yourself.
		
	segment := imageSegment segment.
	outPointers := imageSegment outPointers.
		
	FLSerializer serialize: self toFileNamed: self packageFileName! !

!BMPackage methodsFor: 'as yet unclassified' stamp: 'RL 1/9/2013 12:18'!
import
	root := self loadSegmentFrom: segment outPointers: outPointers! !

!BMPackage methodsFor: 'as yet unclassified' stamp: 'RL 1/9/2013 12:17'!
loadSegmentFrom: segmentWordArray outPointers: outPointerArray
	"This primitive will install a binary image segment and return as its value the array of roots of the tree of objects represented.  Upon successful completion, the wordArray will have been transmuted into an object of zero length.  If this primitive should fail, it will have destroyed the contents of the segment wordArray."

	<primitive: 99>	"successful completion returns the array of roots"
	^ nil			"failure returns nil"! !

!BMPackage methodsFor: 'accessing' stamp: 'RL 1/9/2013 11:21'!
name
	^ name! !

!BMPackage methodsFor: 'accessing' stamp: 'RL 1/9/2013 11:21'!
name: aName
	name := aName! !

!BMPackage methodsFor: 'as yet unclassified' stamp: 'RL 1/9/2013 11:34'!
packageFileName
	^ name, self class packageFileExtension! !

Object subclass: #ExampleProject
	instanceVariableNames: 'foo bar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BinaryModules'!

!ExampleProject methodsFor: 'as yet unclassified' stamp: 'RL 1/7/2013 16:29'!
foobar
	^ foo + bar! !

!ExampleProject methodsFor: 'as yet unclassified' stamp: 'RL 1/7/2013 16:29'!
initialize
	foo := 42.
	bar := 23.! !

Object subclass: #GuineaPig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BinaryModules'!

!GuineaPig methodsFor: 'mistreat' stamp: 'lw 12/21/2012 16:18'!
feedPills
	^ #( die turnYellow turnGreen heal '' ) atRandom! !

!GuineaPig methodsFor: 'treat' stamp: 'dg 12/21/2012 16:25'!
pet
	
	^#purr
	! !

!GuineaPig methodsFor: 'mistreat' stamp: 'lw 12/21/2012 16:13'!
poke
	^ #bite! !

!GuineaPig methodsFor: 'mistreat' stamp: 'lw 12/21/2012 16:17'!
stab
	^#die! !

TestCase subclass: #BMImageSegmentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BinaryModules'!

!BMImageSegmentTest methodsFor: 'as yet unclassified' stamp: 'RL 1/9/2013 11:11'!
testImageSegmentExport
	
	"export a GuineaPig copy"
	ImageSegment new
		copyFromRoots: (Array with: GuineaPig) sizeHint: 1000;
		writeForExport: 'GuineaPig.extSeg'.
	
	"remove the copy"
	self halt.
	GuineaPig removeFromChanges; removeFromSystemUnlogged.
	
	"fileIn and test equality of the saved copy"
	(FileStream fileNamed: 'GuineaPig.extSeg') fileIn
	
	"remove the copy"! !

!BMImageSegmentTest methodsFor: 'as yet unclassified' stamp: 'RL 1/9/2013 11:12'!
testImageSegmentSwapping
	
	self assert: GuineaPig isInMemory.
	ImageSegment new
		copyFromRoots: (Array with: GuineaPig) sizeHint: 1000;
		extract.

	self deny: GuineaPig isInMemory.
	GuineaPig xxxSegment install.
	self assert: GuineaPig isInMemory.
! !

ImageSegment subclass: #BMImageSegment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BinaryModules'!

!BMImageSegment methodsFor: 'read/write segment' stamp: 'lw 12/21/2012 16:10'!
install
	[^super install] ifError: [self halt.]! !
